;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;Horizontal flip.
;by "Martin"
;================================

@DFILE=400C

ORG 4084

@HFLIP
	LD HL,(DFILE)
	LD DE,0010 
	ADD HL,DE 
	LD D,H 
	LD E,L 
	INC DE 
	LD B,18 
@HF01
	LD A,(HL) 
	CP 76 
	JR Z HF02
	EX DE,HL 
	LD C,(HL) 
	LD (HL),A 
	EX DE,HL 
	LD (HL),C 
	DEC HL 
	INC DE 
	JR HF01
@HF02
	LD DE,0031 
	ADD HL,DE 
	LD D,H 
	LD E,L 
	INC DE 
	DJNZ HF01
;================================
;This section added by Greg Harder
;It will properly "flip" the pixel
;characters.
;================================
	LD HL,(DFILE)
	LD BC,0318	;Counter=792=DFILE size
@HF03
	PUSH BC
	INC HL
	LD A,(HL)	;Get character
	BIT 7,A		;Character code>=128?
	JR Z HF04	;No
	SUB 80
	LD DE,HTABLE2	;Use HTABLE2 for codes>=128
	JR HF05		
@HF04
	LD DE,HTABLE1	;Use HTABLE1 for codes<=63
@HF05
	AND A		;The code 0 doesn't
	JR Z HF07	;need to be flipped
	LD B,00		;Test
	LD C,A		;for
	SUB 08		;Valid pixel code?
	JR NC HF07	;IF A>8 THEN not a valid pixel
@HF06
	EX DE,HL	;HL=Table
	ADD HL,BC	;Add offset to table
	LD A,(HL)	;A=Flipped pixel character
	EX DE,HL	;HL=DFILE addr
	LD (HL),A	;Print flipped character
@HF07
	POP BC		;POP counter
	DEC BC		;Decrease counter
	LD A,B 
	OR C
	JR NZ HF03	;IF NZ THEN GOTO HF03
	RET

@HTABLE1
	00 02 01 03 87 85 86 84
@HTABLE2
	80 82 81 83 07 05 06 04
	